
@echo off

:start
setlocal

set cwd=%~p0
cd /D %~p0

IF EXIST "..\_uninst\.tpcreg" goto server
goto agent

:server

REM Set Java runtime
for %%f in ("%cwd%") do set cwd=%%~sf
set JAVAHOME=%cwd%..\jre\bin
if exist "%JAVAHOME%" goto JAVA_SET

echo No Java runtime found ... aborting
goto endscript

:JAVA_SET

REM Set various variables
set arg=
set TPC_PROPERTY_DIR=%cwd%..\config\
for %%f in ("%PROGRAMFILES%") do set PROGRAMFILES=%%~sf
for %%f in ("%USERPROFILE%") do set USERPROFILE=%%~sf
set HOST_FILE_DIR=%PROGRAMFILES%\..\WINDOWS\system32\drivers\etc\
set DATA_SERVICE_DIR=
set SERVICE=false

set MSINFO32_EXE_PATH=%PROGRAMFILES(x86)%\Common Files\Microsoft Shared\MSInfo\msinfo32.exe
if not exist "%MSINFO32_EXE_PATH%" set MSINFO32_EXE_PATH=%PROGRAMFILES%\Common Files\Microsoft Shared\MSInfo\msinfo32.exe

set TPC_INSTALL_DIR=%cwd%..

set JAZZSM_HOME=
set DE_HOME=
set IA_INSTALL_LOG_DIR=
set JAVA_PROPERTIES=

rem
rem want to pass SERVICE_DIR as an argument to java using -D.  but %cwd% adds '\' at the end
rem and it's causing problem when java is run. that's why a '.' is added at the end.
rem we are using this SERVICE_DIR to move all the zip files to this directory and to zip up all the
rem files into one.
set SERVICE_DIR=%cwd%.
for %%f in ("%SERVICE_DIR%") do set SERVICE_DIR=%%~sf

IF NOT "%1"=="" ( set arg=%* ) else ( set arg="-all")

set DEBUG_ARGS=-Djava.compiler=NONE -Xdebug -Xnoagent -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=7800 

set JAVAARGS="-DTPC_SERVICE_DIR=%SERVICE_DIR%"


::Verify write privileges in SERVICE_DIR
set pathfile="%cwd%"
set i=0
set filepath=%pathfile%TestPrivileges%i%

:testIfExists
if not exist %filepath% goto cont
set /A i=%i%+1
set filepath=%filepath:~0,-1%%i%
goto testIfExists

:cont
mkdir %filepath%
if errorlevel 1 goto needrights
rmdir %filepath%
goto runNormal


:needrights
 echo. The user may not have read/write permission on %SERVICE_DIR%.
 echo. Please run the script with a user who does.
 pause
 goto endscript
::End Verify

:runNormal

:DataServer

   REM check for version.txt in IBM Spectrum Control main folder
   IF EXIST "%TPC_PROPERTY_DIR%..\version.txt" xcopy "%TPC_PROPERTY_DIR%..\version.txt" "%~dp0" /y >nul
   REM get the hosts file from windows\system32\drivers\etc directory
   REM xcopy command can not find the hosts file, therefore we must use copy 
   IF EXIST "%HOST_FILE_DIR%hosts" copy "%HOST_FILE_DIR%hosts" "%~dp0" /y >nul
   REM get the name of the license file
   DIR /b "%TPC_PROPERTY_DIR%\..\properties\version\*.swtag" > "%~dp0license.txt" 2>NUL
   IF NOT %ERRORLEVEL% EQU 0 ECHO **NO LICENSE FILE FOUND** > "%~dp0license.txt"
   IF EXIST "%TPC_PROPERTY_DIR%\..\wlp\usr\servers\deviceServer\jvm.options" xcopy "%TPC_PROPERTY_DIR%\..\wlp\usr\servers\deviceServer\jvm.options" "%~dp0" /y >nul

   REM Locate Data Server home directory from Data property file
   IF NOT EXIST "%TPC_PROPERTY_DIR%service.properties" goto :end

   FOR /F "tokens=2* delims==" %%G IN ('findstr /c:"DataServer" "%TPC_PROPERTY_DIR%service.properties"') DO set DATA_SERVICE_DIR=%%G
    
   for %%f in ("%DATA_SERVICE_DIR%") do set DATA_SERVICE_DIR=%%~sf
   
   REM In case Data Server is not installed on the current machine
   if "%DATA_SERVICE_DIR%"=="" set DATA_SERVICE_DIR=%cwd%..\data
   
   ::Building the Data Server service directory
   set DATA_SERVICE_DIR=%DATA_SERVICE_DIR%\service
   
   FOR /F "tokens=2* delims==" %%G IN ('findstr /c:"JazzSM" "%TPC_PROPERTY_DIR%service.properties"') DO set JAZZSM_HOME=%%G
    
   for %%f in ("%JAZZSM_HOME%") do set JAZZSM_HOME=%%~sf
   
   set DE_HOME=%PROGRAMFILES(x86)%\IBM\common\acsi
   if not exist "%DE_HOME%\logs" set DE_HOME=%PROGRAMFILES%\IBM\common\acsi

   set IA_INSTALL_LOG_DIR=%USERPROFILE%

   set JAVA_PROPERTIES=-DJAZZSM_HOME="%JAZZSM_HOME%" -DDE_HOME="%DE_HOME%" -DIA_INSTALL_LOG_DIR="%IA_INSTALL_LOG_DIR%" -DMSINFO32_EXE_PATH="%MSINFO32_EXE_PATH%"

   set classpath=%classpath%;%cwd%..\lib\TPC_Common.jar
  
   echo.
   echo Starting service program for IBM Spectrum Control with arg(s): %arg%

   "%JAVAHOME%\java" %JAVAARGS% %JAVA_PROPERTIES% -cp "%classpath%" com.tivoli.itsrm.tools.Service.Service "%DATA_SERVICE_DIR%" "%PROGRAMFILES%" %arg%
   set SERVICE=true
   if exist hosts del hosts
   if exist version.txt del version.txt
   if exist license.txt del license.txt
   if exist msInfo.txt del msInfo.txt
   if exist jvm.options del jvm.options

   
:zipallserver
   
   goto endserver


:end

   IF %SERVICE%==true goto zipallserver

   IF %SERVICE%==true goto endserver
   
   echo.
   echo Collecting service information for IBM Spectrum Control products. Please wait...
   echo There are no server or agent logs to be collected
   
:endserver
   goto endscript
   
:agent

   set SERVICE_DIR="%CD%"

   echo.
   echo Starting service program for IBM Spectrum Control with arg(s): %*
   echo.   
   echo IBM Spectrum Control Service Program
   echo.
   echo Service directory = %SERVICE_DIR%
   echo.     
   
   set CAPDIR="%ALLUSERSPROFILE%\IBM\CAP"
   set APPEVENT="%systemroot%\system32\config\AppEvent.Evt","%systemroot%\System32\Winevt\Logs\Application.evtx"   
   set APPEVENT1="%systemroot%\system32\config\AppEvent.Evt"
   set APPEVENT2="%systemroot%\System32\Winevt\Logs\Application.evtx" 


set HELP_SELECTED=
set ALL_SELECTED=
set NOZIP_SELECTED=
set OUTPUT_SELECTED=
set SRA_SELECTED=
set OUTPUT_DIR=
set FILENAME_SELECTED=
set FILENAME=

:ParseCommandLine
IF "%OUTPUT_SELECTED%"=="true" goto setoutputdir
IF "%FILENAME_SELECTED%"=="true" goto setfilename

IF "%1"=="" GOTO CollectServiceData
IF "%1"=="-help" goto helpselected
IF "%1"=="-all" goto allselected
IF "%1"=="-nozip" goto nozipselected
IF "%1"=="-output" goto outputselected
IF "%1"=="-sra" goto sraselected
IF "%1"=="-filename" goto filenameselected

goto invalidargumentagent

:setoutputdir
   set OUTPUT_DIR=%1
   goto shiftarguments
   
:setfilename
   set FILENAME=%1
   goto shiftarguments
   
:helpselected
   set HELP_SELECTED=true
   goto shiftarguments

:allselected
   set ALL_SELECTED=true
   goto shiftarguments

:nozipselected
   set NOZIP_SELECTED=true
   goto shiftarguments

:outputselected
   set OUTPUT_SELECTED=true
   goto shiftarguments

:filenameselected
   set FILENAME_SELECTED=true
   goto shiftarguments


:sraselected
   set SRA_SELECTED=true
   goto shiftarguments

:shiftarguments
 IF NOT "%OUTPUT_DIR%"=="" set OUTPUT_SELECTED=
 IF NOT "%FILENAME%"=="" set FILENAME_SELECTED=
 SHIFT

GOTO ParseCommandLine

:CollectServiceData

IF "%HELP_SELECTED%"=="true" goto helpagent
IF "%OUTPUT_DIR%"=="" set OUTPUT_DIR=%CD%\data

if not exist "%OUTPUT_DIR%\nul" mkdir "%OUTPUT_DIR%"

echo Service output directory = %OUTPUT_DIR%
echo Collecting service information for IBM Spectrum Control ...
echo .

%~d0
cd %~p0


FOR /F "usebackq tokens=1,2,3,4,5* delims=._" %%i IN (`date/t`) DO set sDate=%%i
FOR /F "usebackq tokens=1,2,3,4,5* delims=._" %%i IN (`time/t`) DO set sTime=%%i

echo Collecting service information for component: sra

set HTML="%~p0\IBMSpectrumControlServiceInfo.htm"
set CAPDIR="%ALLUSERSPROFILE%\Application Data\IBM\CAP"
set BINDIR=%~p0..\bin
set ROOTDIR=%~p0..

echo ^<html^> > %HTML%
echo ^<head^>  >> %HTML%
echo ^<title^> >> %HTML%
echo IBM Spectrum Control Service Program >> %HTML%
echo ^</title^> >> %HTML%

echo ^<script language=javascript^> >> %HTML%
echo function showHideStuff (whichSection) >> %HTML%
echo {  >> %HTML%
echo 	sectObj = document.getElementById(whichSection); >> %HTML%
echo	if (sectObj.style.display == "none") {   >> %HTML%
echo 		sectObj.style.display = "block";  >> %HTML%
echo	} else {     >> %HTML%
echo 		sectObj.style.display = "none";  >> %HTML%
echo 	}   >> %HTML%
echo }  >> %HTML%
echo ^</script^> >> %HTML%

@REM ***************************************
@REM                OS Info
@REM ***************************************
echo ^<b^> >> %HTML%
echo IBM Spectrum Control Service Program>> %HTML%
echo ^</b^> >> %HTML%
echo ^</h1^>^</head^>^<body^>^<table^>^<pre^>>> %HTML%
echo Date/Time is:  %sDate% %sTime%>> %HTML%
echo ^</pre^> >> %HTML%
echo ^<pre^> >> %HTML%
echo Collecting service information for IBM Spectrum Control products >> %HTML%
echo ^</pre^> >> %HTML%
echo ^<tr^> >> %HTML%
echo ^<td^>^<a href="javascript:showHideStuff('section0');"^>+^</a^>^</td^> >> %HTML%
echo ^<td^>^<u^>^<b^>System Information^</b^>^</u^>^</td^> >> %HTML%
echo ^</tr^> >> %HTML%
echo ^<tr id="section0" style="display:none"^> >> %HTML%
echo ^<td width="5"^>^&nbsp; >> %HTML%
echo ^</td^>^<td^>^<table^>^<tr^>^<td^>^<pre^> >> %HTML%
systeminfo >> %HTML%
echo ^</pre^>^</td^>^</tr^>^</table^>^</td^>^</tr^> >> %HTML%
echo ^<tr^>^<td^>^&nbsp;^</td^>^</tr^> >> %HTML%

@REM ***************************************
@REM           Executing OS Commands
@REM ***************************************
echo ^<tr^> >> %HTML%
echo ^<td^>^<a href="javascript:showHideStuff('section1');"^>+^</a^>^</td^> >> %HTML%
echo ^<td^>^<u^>^<b^>Executing OS/SRA Commands...^</b^>^</u^>^</td^> >> %HTML%
echo ^</tr^> >> %HTML%
echo ^<tr id="section1" style="display:none"^>  ^<td width="5"^>^&nbsp;^</td^> ^<td^>^<table^>^<tr^>^<td^>^<pre^> >> %HTML%


@REM ***************************************
@REM           ipconfig /all
@REM ***************************************
echo ^<tr^> >> %HTML%
echo ^<td^>^<a href="javascript:showHideStuff('section2');"^>+^</a^>^</td^> >> %HTML%
echo ^<td^>^<u^>^<b^>ipconfig /all^</b^>^</u^>^</td^> >> %HTML%
echo ^</tr^> >> %HTML%

echo ^<tr id="section2" style="display:none"^>  ^<td width="5"^>^&nbsp;^</td^> ^<td^>^<table^>^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>ipconfig /all^<- >> %HTML%
ipconfig /all >> %HTML%
echo ^</pre^>^</td^>^</tr^>^</table^>^</td^>^</tr^> >> %HTML%
echo ^<tr^>^<td^>^&nbsp;^</td^>^</tr^> >> %HTML%



@REM ***************************************
@REM             netstat -a
@REM ***************************************
echo ^<tr^> >> %HTML%
echo ^<td^>^<a href="javascript:showHideStuff('section3');"^>+^</a^>^</td^> >> %HTML%
echo ^<td^>^<u^>^<b^>netstat -a^</b^>^</u^>^</td^> >> %HTML%
echo ^</tr^> >> %HTML%

echo ^<tr id="section3" style="display:none"^>  ^<td width="5"^>^&nbsp;^</td^> ^<td^>^<table^>^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>netstat -a^<- >> %HTML%

netstat -a >> %HTML%
echo ^</pre^>^</td^>^</tr^>^</table^>^</td^>^</tr^> >> %HTML%
echo ^<tr^>^<td^>^&nbsp;^</td^>^</tr^> >> %HTML%

@REM ***************************************
@REM     dir c:\program files\ibm\tpc\agent
@REM ***************************************
echo ^<tr^> >> %HTML%
echo ^<td^>^<a href="javascript:showHideStuff('section4');"^>+^</a^>^</td^> >> %HTML%
echo ^<td^>^<u^>^<b^>cmd /C dir %ROOTDIR%^</b^>^</u^>^</td^> >> %HTML%
echo ^</tr^> >> %HTML%

echo ^<tr id="section4" style="display:none"^>  ^<td width="5"^>^&nbsp;^</td^> ^<td^>^<table^>^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C dir %ROOTDIR%^<- >> %HTML%

cmd /C dir "%ROOTDIR%" >> %HTML%
echo ^</pre^>^</td^>^</tr^>^</table^>^</td^>^</tr^> >> %HTML%
echo ^<tr^>^<td^>^&nbsp;^</td^>^</tr^> >> %HTML%

@REM ***************************************
@REM  dir c:\program files\ibm\tpc\agent\bin
@REM ***************************************
echo ^<tr^> >> %HTML%
echo ^<td^>^<a href="javascript:showHideStuff('section5');"^>+^</a^>^</td^> >> %HTML%
echo ^<td^>^<u^>^<b^>cmd /C dir %BINDIR%^</b^>^</u^>^</td^> >> %HTML%
echo ^</tr^> >> %HTML%

echo ^<tr id="section5" style="display:none"^>  ^<td width="5"^>^&nbsp;^</td^> ^<td^>^<table^>^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C dir %BINDIR%^<- >> %HTML%

cmd /C dir  "%BINDIR%" >> %HTML%
echo ^</pre^>^</td^>^</tr^>^</table^>^</td^>^</tr^> >> %HTML%
echo ^<tr^>^<td^>^&nbsp;^</td^>^</tr^> >> %HTML%

@REM ***************************************
@REM          agent -version
@REM ***************************************
echo ^<tr^> >> %HTML%
echo ^<td^>^<a href="javascript:showHideStuff('section6');"^>+^</a^>^</td^> >> %HTML%
echo ^<td^>^<u^>^<b^>Versions of SRA components^</b^>^</u^>^</td^> >> %HTML%
echo ^</tr^> >> %HTML%

echo ^<tr id="section6" style="display:none"^>  ^<td width="5"^>^&nbsp;^</td^> ^<td^>^<table^> >> %HTML%
cd ..

set SRACOMP=Agent.exe
echo ^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C %SRACOMP% -version^<- >> %HTML%
cmd /C bin\%SRACOMP% -version >> %HTML%
echo ^</pre^>^</td^>^</tr^> >> %HTML%

set SRACOMP=DbMonitor.exe
echo ^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C %SRACOMP% -version^<- >> %HTML%
cmd /C bin\%SRACOMP% -version >> %HTML%
echo ^</pre^>^</td^>^</tr^> >> %HTML%

set SRACOMP=Discovery.exe
echo ^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C %SRACOMP% -version^<- >> %HTML%
cmd /C bin\%SRACOMP% -version >> %HTML%
echo ^</pre^>^</td^>^</tr^> >> %HTML%

set SRACOMP=FabricDiscovery.exe
echo ^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C %SRACOMP% -version^<- >> %HTML%
cmd /C bin\%SRACOMP% -version >> %HTML%
echo ^</pre^>^</td^>^</tr^> >> %HTML%

set SRACOMP=FabricProbe.exe
echo ^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C %SRACOMP% -version^<- >> %HTML%
cmd /C bin\%SRACOMP% -version >> %HTML%
echo ^</pre^>^</td^>^</tr^> >> %HTML%

set SRACOMP=FabricZoneControl.exe
echo ^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C %SRACOMP% -version^<- >> %HTML%
cmd /C bin\%SRACOMP% -version >> %HTML%
echo ^</pre^>^</td^>^</tr^> >> %HTML%

set SRACOMP=NasFilerProbe.exe
echo ^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C %SRACOMP% -version^<- >> %HTML%
cmd /C bin\%SRACOMP% -version >> %HTML%
echo ^</pre^>^</td^>^</tr^> >> %HTML%

set SRACOMP=PathPlanner.exe
echo ^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C %SRACOMP% -version^<- >> %HTML%
cmd /C bin\%SRACOMP% -version >> %HTML%
echo ^</pre^>^</td^>^</tr^> >> %HTML%

set SRACOMP=Probe.exe
echo ^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C %SRACOMP% -version^<- >> %HTML%
cmd /C bin\%SRACOMP% -version >> %HTML%
echo ^</pre^>^</td^>^</tr^> >> %HTML%

set SRACOMP=Scan.exe
echo ^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C %SRACOMP% -version^<- >> %HTML%
cmd /C bin\%SRACOMP% -version >> %HTML%
echo ^</pre^>^</td^>^</tr^> >> %HTML%

set SRACOMP=SRAutil.exe
echo ^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C %SRACOMP% -version^<- >> %HTML%
cmd /C bin\%SRACOMP% -version >> %HTML%
echo ^</pre^>^</td^>^</tr^> >> %HTML%

set SRACOMP=TSMDriver.exe
echo ^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>cmd /C %SRACOMP% -version^<- >> %HTML%
cmd /C bin\%SRACOMP% -version >> %HTML%
echo ^</pre^>^</td^>^</tr^> >> %HTML%

echo ^</table^>^</td^>^</tr^> >> %HTML%
echo ^<tr^>^<td^>^&nbsp;^</td^>^</tr^> >> %HTML%


@REM ***************************************
@REM           fsutil volume diskfree C:
@REM ***************************************
echo ^<tr^> >> %HTML%
echo ^<td^>^<a href="javascript:showHideStuff('section7');"^>+^</a^>^</td^> >> %HTML%
echo ^<td^>^<u^>^<b^>fsutil volume diskfree %PROGRAMFILES:~0,2%^</b^>^</u^>^</td^> >> %HTML%
echo ^</tr^> >> %HTML%

echo ^<tr id="section7" style="display:none"^>  ^<td width="5"^>^&nbsp;^</td^> ^<td^>^<table^>^<tr^>^<td^>^<pre^> >> %HTML%
echo Cmd str to execute is -^>fsutil volume diskfree %PROGRAMFILES:~0,2%^<- >> %HTML%
fsutil volume diskfree %PROGRAMFILES:~0,2% >> %HTML%
echo ^</pre^>^</td^>^</tr^>^</table^>^</td^>^</tr^> >> %HTML%
echo ^<tr^>^<td^>^&nbsp;^</td^>^</tr^> >> %HTML%


echo ^</pre^>^</td^>^</tr^>^</table^>^</td^>^</tr^> >> %HTML%
echo ^<tr^>^<td^>^&nbsp;^</td^>^</tr^> >> %HTML%

set SRACOMP=

echo ^</table^> >> %HTML%
echo ^</body^> >> %HTML%
echo ^</html^> >> %HTML%

@REM ****************************************
@REM            Get tasklist
@REM ****************************************

tasklist > service\Process.txt

@REM ****************************************
@REM            Get install logs
@REM ****************************************

set tmpdir=%CD%

if not exist "%CD%\..\log\sra" goto skipInstallLogs

cd ..
set INSTALL_FILES="%CD%\log\sra"
cd "%tmpdir%"

:skipInstallLogs

@REM ****************************************
@REM            Get HBAInfo
@REM ****************************************

:BIT32
if exist service\HBAInfo.txt del service\HBAInfo.txt
reg export HKLM\SOFTWARE\SNIA\HBA service\HBAInfo.txt 2> nul
IF %ERRORLEVEL% EQU 0 goto ZIPIT

:BIT64
if exist service\HBAInfo.txt del service\HBAInfo.txt
reg export HKLM\SOFTWARE\Wow6432Node\SNIA\HBA service\HBAInfo.txt 2> nul
IF %ERRORLEVEL% EQU 0 goto ZIPIT

echo No HBA registry entry found.


@REM ****************************************
@REM        Create service zip file
@REM ****************************************

:ZIPIT
set VPD64="%CommonProgramFiles(x86)%\InstallShield\Universal\IBM-TPC\Gen1\_vpddb\vpd.script"

set VPD="%CommonProgramFiles%\InstallShield\Universal\IBM-TPC\Gen1\_vpddb\vpd.script"

if exist %VPD64% copy %VPD64% 
if exist %VPD% copy %VPD%

set DMPS=
for %%X in ( bin/*crash* ) do call :AddToDMPS bin\%%X 
echo Service completed successfully for Component: sra
echo Service information was collected in %OUTPUT_DIR%
goto zipAllAgent

:AddToDMPS
if "%DMPS%"=="" (
   SET DMPS=%1 
) else ( 
  set DMPS=%DMPS%,%1
)

set DMPS=%DMPS: =%
goto :EOF

:zipAllAgent
IF "%NOZIP_SELECTED%"=="true" goto unzipAgent
bin\Agent -zip -name "%OUTPUT_DIR%\IBMSpectrumControlServiceInfo.zip" -files %CAPDIR%,%APPEVENT1%,service\Process.txt,vpd.script,service\HBAInfo.txt,service\IBMSpectrumControlServiceInfo.htm,version.txt,config,log,output,nls,%INSTALL_FILES% -force

goto printagentscriptcomplete

:unzipAgent
   if exist "%OUTPUT_DIR%\sra" rmdir /S /Q "%OUTPUT_DIR%\sra"
   if not exist "%OUTPUT_DIR%\sra" mkdir "%OUTPUT_DIR%\sra"
   if not exist "%OUTPUT_DIR%\sra\Documents" mkdir "%OUTPUT_DIR%\sra\Documents" 
   xcopy /C /S /Q /F /Y %CAPDIR% "%OUTPUT_DIR%\sra\Documents"
   if not exist "%OUTPUT_DIR%\sra\WINDOWS" mkdir "%OUTPUT_DIR%\sra\WINDOWS"  
   copy %APPEVENT1% "%OUTPUT_DIR%\sra\WINDOWS"
   copy %APPEVENT2% "%OUTPUT_DIR%\sra\WINDOWS"   
   mkdir "%OUTPUT_DIR%\sra\service"   
   copy "%SERVICE_DIR%\Process.txt" "%OUTPUT_DIR%\sra\service"
   copy "%SERVICE_DIR%\HBAInfo.txt" "%OUTPUT_DIR%\sra\service"
   copy "%SERVICE_DIR%\IBMSpectrumControlServiceInfo.htm" "%OUTPUT_DIR%\sra\service"
   copy "%SERVICE_DIR%\..\version.txt" "%OUTPUT_DIR%\sra"
   if not exist "%OUTPUT_DIR%\sra\config" mkdir "%OUTPUT_DIR%\sra\config"   
   xcopy /C /S /Q /F /Y "%SERVICE_DIR%\..\config" "%OUTPUT_DIR%\sra\config"
   if not exist "%OUTPUT_DIR%\sra\log" mkdir "%OUTPUT_DIR%\sra\log"   
   xcopy /C /S /Q /F /Y "%SERVICE_DIR%\..\log" "%OUTPUT_DIR%\sra\log"
   if not exist "%OUTPUT_DIR%\sra\output" mkdir "%OUTPUT_DIR%\sra\output"   
   xcopy /C /S /Q /F /Y "%SERVICE_DIR%\..\output" "%OUTPUT_DIR%\sra\output"
   if not exist "%OUTPUT_DIR%\sra\nls" mkdir "%OUTPUT_DIR%\sra\nls"   
   xcopy /C /S /Q /F /Y "%SERVICE_DIR%\..\nls" "%OUTPUT_DIR%\sra\nls"
   if not exist "%OUTPUT_DIR%\sra\installfiles" mkdir "%OUTPUT_DIR%\sra\installfiles"
   if exist %INSTALL_FILES% xcopy /C /S /Q /F /Y "%INSTALL_FILES%" "%OUTPUT_DIR%\sra\installfiles"         
   goto printagentscriptcomplete

:printagentscriptcomplete
   if exist vpd.script del vpd.script
   del service\IBMSpectrumControlServiceInfo.htm service\Process.txt service\HBAInfo.txt
   echo Service completed successfully. Exiting Service Tool
   echo Send the service file to IBM for diagnostic evaluation
   goto endscript
   
:helpagent  
   set TEXT=Usage: service [options]
   echo %TEXT%
   set TEXT=Option -all will be applied when no parameter is present
   echo %TEXT%
   echo.
   set TEXT=Options:
   echo %TEXT%
   set TEXT=                -all          Collect service files for Storage Resource Agent
   echo %TEXT%
   set TEXT=                -sra          Collect service files for Storage Resource Agent
   echo %TEXT%
   set TEXT=                -help         Show usages
   echo %TEXT%
   set TEXT=                -nozip        Do not compress the service files
   echo %TEXT%
   set TEXT=                -output dir   Specify the output directory
   echo %TEXT%
   set TEXT=                -filename name Specify the output filename
   echo %TEXT%
   echo.       
   goto endscript 
   
:invalidargumentagent   
   set TEXT=One or more of the options that were entered are invalid. See the help menu (option -help) for more information.
   echo %TEXT%
   goto endscript
       
:endscript

endlocal

